#!/usr/bin/php -q
<?
require_once("sqli.php");

$hist_path = getenv("HOME")."/.SQLishell_history";

define('PARM_NONE', 0);
define('PARM_NUM', 1);
define('PARM_STR', 2);

$_sqli_shell_msgs = array(
	array(
		SELECT_CMD,
		"(selected rows: %d)",
		"(selected rows: %d)",
		strlen(SELECT_CMD),
		PARM_NUM,
		"show_records"
	),
	array(
		INSERT_CMD,
		"INSERT OK",
		"INSERT FAILED",
		strlen(INSERT_CMD),
		PARM_NONE,
		FALSE
	),
	array(
		UPDATE_CMD,
		"(affected rows: %d)",
		"(affected rows: %d)",
		strlen(UPDATE_CMD),
		PARM_NUM,
		FALSE
	),
	array(
		CREATE_TABLE_CMD,
		"CREATE TABLE OK",
		"CREATE TABLE FAILED",
		strlen(CREATE_TABLE_CMD),
		PARM_NONE,
		FALSE
	),
	array(
		CREATE_DB_CMD,
		"CREATE DATABASE OK",
		"CREATE DATABASE FAILED",
		strlen(CREATE_DB_CMD),
		PARM_NONE,
		FALSE
	),
	array(
		CREATE_INDEX_CMD,
		"CREATE INDEX OK",
		"CREATE INDEX FAILED",
		strlen(CREATE_INDEX_CMD),
		PARM_NONE,
		FALSE
	),
	array(
		CREATE_SEQ_CMD,
		"CREATE SEQUENCE OK",
		"CREATE SEQUENCE FAILED",
		strlen(CREATE_SEQ_CMD),
		PARM_NONE,
		FALSE
	),
	array(
		DROP_TABLE_CMD,
		"DROP TABLE OK",
		"DROP TABLE FAILED",
		strlen(DROP_TABLE_CMD),
		PARM_NONE,
		FALSE
	),
	array(
		DROP_DB_CMD,
		"DROP DATABASE OK",
		"DROP DATABASE FAILED",
		strlen(DROP_DB_CMD),
		PARM_NONE,
		FALSE
	),
	array(
		DROP_IDX_CMD,
		"DROP INDEX OK",
		"DROP INDEX FAILED",
		strlen(DROP_INDEX_CMD),
		PARM_NONE,
		FALSE
	),
	array(
		DROP_SEQ_CMD,
		"DROP SEQUENCE OK",
		"DROP SEQUENCE FAILED",
		strlen(DROP_SEQ_CMD),
		PARM_NONE,
		FALSE
	),
	array(
		DELETE_CMD,
		"(affected rows: %d)",
		"(affected rows: %d)",
		strlen(DELETE_CMD),
		PARM_NUM,
		FALSE
	),
	array(
		TRUNCATE_CMD,
		"TRUNCATE OK",
		"TRUNCATE FAILED",
		strlen(TRUNCATE_CMD),
		PARM_NONE,
		FALSE
	),
	array(
		REPLACE_CMD,
		"(affected rows: %d)",
		"(affected rows: %d)",
		strlen(REPLACE_CMD),
		PARM_NUM,
		FALSE
	),
	array(
		SHOW_DBS_CMD,
		"(selected rows: %d)",
		"(selected rows: %d)",
		strlen(SHOW_DDBD),
		PARM_NUM,
		"show_records"
	),
	array(
		SHOW_TABLES_CMD,
		"(selected rows: %d)",
		"(selected rows: %d)",
		strlen(SHOW_TABLES_CMD),
		PARM_NUM,
		"show_records"
	),
	array(
		SHOW_SEQUENCES_CMD,
		"(selected rows: %d)",
		"(selected rows: %d)",
		strlen(SHOW_SEQUENCES_CMD),
		PARM_NUM,
		"show_records"
	),
	array(
		SHOW_INDICES_CMD,
		"(selected rows: %d)",
		"(selected rows: %d)",
		strlen(SHOW_INDICES_CMD),
		PARM_NUM,
		"show_records"
	),
	array(
		USE_CMD,
		"(connected to %s)",
		"(connection failed to %s)",
		strlen(USE_CMD),
		PARM_STR,
		FALSE
	)
);

$db = &new SQLi;

if($hist_path)
	readline_read_history($hist_path);
do
{
	unset($cmd);
	$cmd = trim(readline("SQLi> "), " \t\n\r\0\x0B;");
	if(strlen($cmd))
	{
		my_readline_add_history($cmd);
		if(!strcasecmp($cmd, "quit")) break;
		$res = $db->query($cmd);
		if($res) $db->flush();
		if(!strncasecmp($cmd, "USE ", 4) && $res) $res = $db->dbh->name;
		print_msg($cmd, $res);
		unset($res);
	}
} while($cmd);
unset($cmd);

if($db->isconnected())
{
	$db->close();
}

if($hist_path)
	readline_write_history($hist_path);
exit;

function print_msg($cmd, $res)
{
	global $_sqli_shell_msgs;

	for($i = 0 ; $i < count($_sqli_shell_msgs) ; $i++)
	{
		$m = $_sqli_shell_msgs[$i];
		if(preg_match($m[0], $cmd." "))
		{
			unset($i);
			break;
		}
		unset($m);
	}

	if($m)
	{
		if($res)
		{
			if($m[5]) $res = $m[5]($res);
			if($m[4])
				echo sprintf($m[1], $res)."\n";
			else
				echo $m[1]."\n";
		}
		else
		{
			if($m[4])
				echo sprintf($m[2], $res)."\n";
			else
				echo $m[2]."\n";
		}
		echo "\n";
	}
}

function show_records($recs)
{
	$recs = $recs->result;

	if(!is_array($recs[1])) return 0;
	unset($recs[0]);
	$recs[0] = array();

	foreach($recs[1] as $k=>$v)
	{
		$recs[0][$k] = $k;
	}
	reset($recs[1]);

	for($i = 0 ; $i < count($recs) ; $i++)
	{
		if(is_array($recs[$i]))
		{
			foreach($recs[$i] as $k=>$v)
			{
				if($widths[$k] < strlen($v))
				{
					$widths[$k] = strlen($v);
				}
			}
			reset($recs[$i]);
		}
	}

	$line = "+";
	foreach($widths as $k=>$w)
	{
		$line .= str_repeat("-", $w+2);
		$line .= '+';
	}
	reset($widths);

	$line .= "\n";
	for($i = 0 ; $i < count($recs) ; $i++)
	{
		echo $line;
		echo "|";
		foreach($recs[$i] as $k=>$v)
		{
			if(!$v) $v = 'NULL';
			printf(" %-".$widths[$k]."s |", $v);
		}
		echo "\n";
	}
	echo $line;

	if($i) $i--;
	return $i;
}

function my_readline_add_history($line)
{
	$check = "/^".preg_quote($line)."$/i";
	if(!count(preg_grep($check, readline_list_history())))
	{
		readline_add_history($line);
	}
	else
	{
		$tmp = readline_list_history();
		if(is_array($tmp) && count($tmp))
		{
			foreach($tmp as $l)
			{
				if(!preg_match($check, $l))
				{
					$newhist[] = $l;
				}
				unset($l);
			}
			$newhist[] = $line;
			unset($tmp);
		}
		else $newhist[] = $line;

		readline_clear_history();
		foreach($newhist as $l)
		{
			readline_add_history($l);
			unset($l);
		}
		unset($newhist);
	}
	unset($check);
}

?>
